diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/AbstractBundler.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/AbstractBundler.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/AbstractBundler.java	Wed Dec 06 17:33:43 2017 -0800
@@ -38,6 +38,10 @@
 import java.util.*;
 import com.oracle.tools.packager.IOUtils;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public abstract class AbstractBundler implements Bundler {
 
     private static final ResourceBundle I18N =
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/AbstractImageBundler.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/AbstractImageBundler.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/AbstractImageBundler.java	Wed Dec 06 17:33:43 2017 -0800
@@ -44,7 +44,10 @@
 
 /**
  * Common utility methods used by app image bundlers.
+ * 
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
  */
+@Deprecated(since="10", forRemoval=true)
 public abstract class AbstractImageBundler extends AbstractBundler {
 
     private static final ResourceBundle I18N =
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/BasicBundlers.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/BasicBundlers.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/BasicBundlers.java	Wed Dec 06 17:33:43 2017 -0800
@@ -58,7 +58,10 @@
  *     <LI>Linux RPM</LI>
  *
  * </UL>
+ * 
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
  */
+@Deprecated(since="10", forRemoval=true)
 public class BasicBundlers implements Bundlers {
 
     boolean defaultsLoaded = false;
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/Bundler.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/Bundler.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/Bundler.java	Wed Dec 06 17:33:43 2017 -0800
@@ -29,9 +29,11 @@
 import java.util.Collection;
 import java.util.Map;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public interface Bundler {
-
-
     /**
      * @return User Friendly name of this bundler.
      */
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/BundlerParamInfo.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/BundlerParamInfo.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/BundlerParamInfo.java	Wed Dec 06 17:33:43 2017 -0800
@@ -30,8 +30,11 @@
 import java.util.function.BiFunction;
 import java.util.function.Function;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class BundlerParamInfo<T> {
-
     /**
      * The user friendly name of the parameter
      */
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/Bundlers.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/Bundlers.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/Bundlers.java	Wed Dec 06 17:33:43 2017 -0800
@@ -29,7 +29,10 @@
 import java.util.Iterator;
 import java.util.ServiceLoader;
 
-
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public interface Bundlers {
 
     /**
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/ConfigException.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/ConfigException.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/ConfigException.java	Wed Dec 06 17:33:43 2017 -0800
@@ -25,6 +25,10 @@
 
 package com.oracle.tools.packager;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class ConfigException extends Exception {
     final String advice;
 
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/EnumeratedBundlerParam.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/EnumeratedBundlerParam.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/EnumeratedBundlerParam.java	Wed Dec 06 17:33:43 2017 -0800
@@ -49,7 +49,9 @@
  *     params.put(MAC_CATEGORY.getID(), value);
  * }</pre>
  *
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
  */
+@Deprecated(since="10", forRemoval=true)
 public class EnumeratedBundlerParam<T> extends BundlerParamInfo<T> {
     //Not sure if this is the correct order, my idea is that from and IDE's perspective
     //the string to display to the user is the key and then the value is some type of
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/IOUtils.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/IOUtils.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/IOUtils.java	Wed Dec 06 17:33:43 2017 -0800
@@ -31,6 +31,10 @@
 import java.nio.channels.FileChannel;
 import java.util.Arrays;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class IOUtils {
 
     public static boolean deleteRecursive(File path) throws FileNotFoundException {
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/InvalidBundlerParamException.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/InvalidBundlerParamException.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/InvalidBundlerParamException.java	Wed Dec 06 17:33:43 2017 -0800
@@ -25,6 +25,10 @@
 
 package com.oracle.tools.packager;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class InvalidBundlerParamException extends RuntimeException {
     public InvalidBundlerParamException(String message) {
         super(message);
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/JreUtils.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/JreUtils.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/JreUtils.java	Wed Dec 06 17:33:43 2017 -0800
@@ -29,6 +29,10 @@
 import java.util.HashSet;
 import java.util.Set;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class JreUtils {
 
     public static class Rule {
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/Log.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/Log.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/Log.java	Wed Dec 06 17:33:43 2017 -0800
@@ -29,6 +29,10 @@
 import java.io.IOException;
 import java.io.PrintStream;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class Log {
     public static class Logger {
         private boolean verbose = false;
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/Platform.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/Platform.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/Platform.java	Wed Dec 06 17:33:43 2017 -0800
@@ -44,8 +44,10 @@
  *      //TODO Do something else
  *    }
  *  }
+ * 
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
  */
-
+@Deprecated(since="10", forRemoval=true)
 public enum Platform {UNKNOWN, WINDOWS, LINUX, MAC;
     private static final Platform platform;
     private static final int majorVersion;
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/RelativeFileSet.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/RelativeFileSet.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/RelativeFileSet.java	Wed Dec 06 17:33:43 2017 -0800
@@ -31,6 +31,10 @@
 import java.util.LinkedHashSet;
 import java.util.Set;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class RelativeFileSet {
 
     public enum Type {
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/StandardBundlerParam.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/StandardBundlerParam.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/StandardBundlerParam.java	Wed Dec 06 17:33:43 2017 -0800
@@ -59,6 +59,10 @@
 import static jdk.packager.internal.legacy.JLinkBundlerHelper.findPathOfModule;
 import static jdk.packager.internal.legacy.JLinkBundlerHelper.listOfPathToString;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class StandardBundlerParam<T> extends BundlerParamInfo<T> {
 
     public static final String MANIFEST_JAVAFX_MAIN ="JavaFX-Application-Class";
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/oracle/tools/packager/UnsupportedPlatformException.java
--- a/modules/jdk.packager/src/main/java/com/oracle/tools/packager/UnsupportedPlatformException.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/oracle/tools/packager/UnsupportedPlatformException.java	Wed Dec 06 17:33:43 2017 -0800
@@ -25,4 +25,8 @@
 
 package com.oracle.tools.packager;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class UnsupportedPlatformException extends Exception {}
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/CachingPrintStream.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/CachingPrintStream.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/CachingPrintStream.java	Wed Dec 06 17:33:43 2017 -0800
@@ -27,6 +27,10 @@
 
 import java.io.PrintStream;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class CachingPrintStream {
 
     private PrintStream ps;
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/CommonParams.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/CommonParams.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/CommonParams.java	Wed Dec 06 17:33:43 2017 -0800
@@ -27,8 +27,11 @@
 
 import java.io.File;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public abstract class CommonParams {
-
     File outdir;
     boolean verbose;
 
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/CreateBSSParams.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/CreateBSSParams.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/CreateBSSParams.java	Wed Dec 06 17:33:43 2017 -0800
@@ -31,6 +31,10 @@
 import java.util.ArrayList;
 import java.util.List;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class CreateBSSParams extends CommonParams {
     final List<PackagerResource> resources = new ArrayList<PackagerResource>();
 
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/CreateJarParams.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/CreateJarParams.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/CreateJarParams.java	Wed Dec 06 17:33:43 2017 -0800
@@ -31,8 +31,11 @@
 import java.util.List;
 import java.util.Map;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class CreateJarParams extends CommonParams {
-
     final List<PackagerResource> resources = new ArrayList<PackagerResource>();
 
     String applicationClass;
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/DeployParams.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/DeployParams.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/DeployParams.java	Wed Dec 06 17:33:43 2017 -0800
@@ -47,7 +47,10 @@
 
 import static com.oracle.tools.packager.jnlp.JNLPBundler.*;
 
-@Deprecated
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class DeployParams extends CommonParams {
     public enum RunMode {
         WEBSTART, EMBEDDED, STANDALONE, ALL
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/HtmlParam.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/HtmlParam.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/HtmlParam.java	Wed Dec 06 17:33:43 2017 -0800
@@ -25,7 +25,10 @@
 
 package com.sun.javafx.tools.packager;
 
-
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class HtmlParam extends Param {
     boolean needEscape = true;
 
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/JSCallback.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/JSCallback.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/JSCallback.java	Wed Dec 06 17:33:43 2017 -0800
@@ -29,8 +29,9 @@
  * Ant-independent version of the Callback class.
  *
  * @see com.sun.javafx.tools.ant.Callback
- *
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
  */
+@Deprecated(since="10", forRemoval=true)
 class JSCallback {
 
     private String name;
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/JarSignature.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/JarSignature.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/JarSignature.java	Wed Dec 06 17:33:43 2017 -0800
@@ -80,7 +80,10 @@
  *   - add entries using updateWithEntry()
  *   - use isValid() to validate result
  *   - use getCodeSigners() to get list of code signers used
+ * 
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
  */
+@Deprecated(since="10", forRemoval=true)
 public class JarSignature {
     //name of jar manifest attribute that contains signature
     public static final String BLOB_SIGNATURE = "META-INF/SIGNATURE.BSF";
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/Log.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/Log.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/Log.java	Wed Dec 06 17:33:43 2017 -0800
@@ -29,6 +29,10 @@
 import java.io.IOException;
 import java.io.PrintStream;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class Log extends com.oracle.tools.packager.Log {
     public static class Logger extends com.oracle.tools.packager.Log.Logger{
         public Logger(boolean v) {
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/Main.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/Main.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/Main.java	Wed Dec 06 17:33:43 2017 -0800
@@ -42,7 +42,10 @@
 
 import jdk.packager.internal.legacy.JLinkBundlerHelper;
 
-
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class Main {
 
     private static final ResourceBundle bundle =
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/MakeAllParams.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/MakeAllParams.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/MakeAllParams.java	Wed Dec 06 17:33:43 2017 -0800
@@ -25,6 +25,10 @@
 
 package com.sun.javafx.tools.packager;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class MakeAllParams {
     String appClass;
     String preloader;
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/PackagerException.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/PackagerException.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/PackagerException.java	Wed Dec 06 17:33:43 2017 -0800
@@ -28,7 +28,10 @@
 import java.text.MessageFormat;
 import java.util.ResourceBundle;
 
-
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class PackagerException extends Exception {
     private static final ResourceBundle bundle =
             ResourceBundle.getBundle("com/sun/javafx/tools/packager/Bundle");
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/PackagerLib.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/PackagerLib.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/PackagerLib.java	Wed Dec 06 17:33:43 2017 -0800
@@ -81,6 +81,10 @@
 import java.util.zip.ZipEntry;
 import java.util.zip.ZipOutputStream;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class PackagerLib {
     public static final String JAVAFX_VERSION = System.getProperty("java.version");
 
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/Param.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/Param.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/Param.java	Wed Dec 06 17:33:43 2017 -0800
@@ -25,7 +25,10 @@
 
 package com.sun.javafx.tools.packager;
 
-
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class Param {
     String name;
     String value;
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/SignJarParams.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/SignJarParams.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/SignJarParams.java	Wed Dec 06 17:33:43 2017 -0800
@@ -31,6 +31,10 @@
 import java.util.ArrayList;
 import java.util.List;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class SignJarParams extends CommonParams {
 
     final List<PackagerResource> resources = new ArrayList<PackagerResource>();
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/TemplatePlaceholders.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/TemplatePlaceholders.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/TemplatePlaceholders.java	Wed Dec 06 17:33:43 2017 -0800
@@ -25,6 +25,10 @@
 
 package com.sun.javafx.tools.packager;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public enum TemplatePlaceholders {
 
     //location of dtjava.js
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/BundleParams.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/BundleParams.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/BundleParams.java	Wed Dec 06 17:33:43 2017 -0800
@@ -39,7 +39,10 @@
 
 import jdk.packager.internal.legacy.JLinkBundlerHelper;
 
-
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class BundleParams {
 
     final protected Map<String, ? super Object> params;
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/Bundler.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/Bundler.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/Bundler.java	Wed Dec 06 17:33:43 2017 -0800
@@ -25,7 +25,10 @@
 
 package com.sun.javafx.tools.packager.bundlers;
 
-@Deprecated
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public final class Bundler {
 
     private Bundler() {}
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/ConfigException.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/ConfigException.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/ConfigException.java	Wed Dec 06 17:33:43 2017 -0800
@@ -25,6 +25,10 @@
 
 package com.sun.javafx.tools.packager.bundlers;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class ConfigException extends com.oracle.tools.packager.ConfigException {
 
     public ConfigException(String msg, String advice) {
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/RelativeFileSet.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/RelativeFileSet.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/RelativeFileSet.java	Wed Dec 06 17:33:43 2017 -0800
@@ -31,6 +31,10 @@
 import java.util.LinkedHashSet;
 import java.util.Set;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class RelativeFileSet extends com.oracle.tools.packager.RelativeFileSet {
     public RelativeFileSet(File base, Set<File> files) {
         super(base, files);
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/UnsupportedPlatformException.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/UnsupportedPlatformException.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/packager/bundlers/UnsupportedPlatformException.java	Wed Dec 06 17:33:43 2017 -0800
@@ -25,4 +25,8 @@
 
 package com.sun.javafx.tools.packager.bundlers;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class UnsupportedPlatformException extends com.oracle.tools.packager.UnsupportedPlatformException {}
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/ConsolidatedResources.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/ConsolidatedResources.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/ConsolidatedResources.java	Wed Dec 06 17:33:43 2017 -0800
@@ -30,6 +30,10 @@
 import java.util.SortedMap;
 import java.util.TreeMap;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public final class ConsolidatedResources {
     private final SortedMap<ResourceKey, ResourceRecord> resourceMap;
 
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/DeployResource.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/DeployResource.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/DeployResource.java	Wed Dec 06 17:33:43 2017 -0800
@@ -27,6 +27,10 @@
 
 import java.io.File;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class DeployResource extends PackagerResource {
     private final Type type;
     private final String mode;
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/DetailedResourceTraversal.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/DetailedResourceTraversal.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/DetailedResourceTraversal.java	Wed Dec 06 17:33:43 2017 -0800
@@ -27,6 +27,10 @@
 
 import java.io.File;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public abstract class DetailedResourceTraversal implements ResourceTraversal {
     private String lastRelativePath;
 
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/PackagerResource.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/PackagerResource.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/PackagerResource.java	Wed Dec 06 17:33:43 2017 -0800
@@ -27,6 +27,10 @@
 
 import java.io.File;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public class PackagerResource {
     private static final ResourceFilter ACCEPT_ALL_FILTER =
             new ResourceFilter() {
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/ResourceFilter.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/ResourceFilter.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/ResourceFilter.java	Wed Dec 06 17:33:43 2017 -0800
@@ -27,6 +27,10 @@
 
 import java.io.File;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public interface ResourceFilter {
     boolean descent(File file, String relativePath);
 
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/ResourceTraversal.java
--- a/modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/ResourceTraversal.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/com/sun/javafx/tools/resource/ResourceTraversal.java	Wed Dec 06 17:33:43 2017 -0800
@@ -27,6 +27,10 @@
 
 import java.io.File;
 
+/**
+ * @deprecated use {@link ToolProvider} to locate the {@code "javapackager"} tool instead.
+ */
+@Deprecated(since="10", forRemoval=true)
 public interface ResourceTraversal {
     boolean traverse(PackagerResource rootResource,
                      File file,
diff -r 279160e9b5a0 modules/jdk.packager/src/main/java/module-info.java
--- a/modules/jdk.packager/src/main/java/module-info.java	Tue Dec 05 16:56:27 2017 -0800
+++ b/modules/jdk.packager/src/main/java/module-info.java	Wed Dec 06 17:33:43 2017 -0800
@@ -29,6 +29,7 @@
  * @moduleGraph
  * @since 9
  */
+@SuppressWarnings("removal")
 module jdk.packager {
     requires jdk.jlink;
 