diff -r d230a0406623 src/jdk.hotspot.agent/share/classes/module-info.java
--- a/src/jdk.hotspot.agent/share/classes/module-info.java	Sat Feb 16 21:15:33 2019 +0100
+++ b/src/jdk.hotspot.agent/share/classes/module-info.java	Mon Feb 18 17:53:08 2019 +0900
@@ -47,4 +47,99 @@
     // RMI needs to serialize types in this package
     exports sun.jvm.hotspot.debugger.remote to java.rmi;
 
+    opens sun.jvm.hotspot;
+    opens sun.jvm.hotspot.debugger;
+    opens sun.jvm.hotspot.debugger.windbg;
+    opens sun.jvm.hotspot.debugger.windbg.amd64;
+    opens sun.jvm.hotspot.debugger.windbg.x86;
+    opens sun.jvm.hotspot.debugger.windows.amd64;
+    opens sun.jvm.hotspot.debugger.windows.x86;
+    opens sun.jvm.hotspot.debugger.ppc64;
+    opens sun.jvm.hotspot.debugger.posix;
+    opens sun.jvm.hotspot.debugger.posix.elf;
+    opens sun.jvm.hotspot.debugger.win32.coff;
+    opens sun.jvm.hotspot.debugger.amd64;
+    opens sun.jvm.hotspot.debugger.x86;
+    opens sun.jvm.hotspot.debugger.remote;
+    opens sun.jvm.hotspot.debugger.remote.ppc64;
+    opens sun.jvm.hotspot.debugger.remote.amd64;
+    opens sun.jvm.hotspot.debugger.remote.x86;
+    opens sun.jvm.hotspot.debugger.remote.sparc;
+    opens sun.jvm.hotspot.debugger.remote.aarch64;
+    opens sun.jvm.hotspot.debugger.dummy;
+    opens sun.jvm.hotspot.debugger.cdbg;
+    opens sun.jvm.hotspot.debugger.cdbg.basic;
+    opens sun.jvm.hotspot.debugger.bsd;
+    opens sun.jvm.hotspot.debugger.bsd.amd64;
+    opens sun.jvm.hotspot.debugger.bsd.x86;
+    opens sun.jvm.hotspot.debugger.sparc;
+    opens sun.jvm.hotspot.debugger.aarch64;
+    opens sun.jvm.hotspot.debugger.proc;
+    opens sun.jvm.hotspot.debugger.proc.ppc64;
+    opens sun.jvm.hotspot.debugger.proc.amd64;
+    opens sun.jvm.hotspot.debugger.proc.x86;
+    opens sun.jvm.hotspot.debugger.proc.sparc;
+    opens sun.jvm.hotspot.debugger.proc.aarch64;
+    opens sun.jvm.hotspot.debugger.linux;
+    opens sun.jvm.hotspot.debugger.linux.ppc64;
+    opens sun.jvm.hotspot.debugger.linux.amd64;
+    opens sun.jvm.hotspot.debugger.linux.x86;
+    opens sun.jvm.hotspot.debugger.linux.sparc;
+    opens sun.jvm.hotspot.debugger.linux.aarch64;
+    opens sun.jvm.hotspot.types;
+    opens sun.jvm.hotspot.types.basic;
+    opens sun.jvm.hotspot.memory;
+    opens sun.jvm.hotspot.tools;
+    opens sun.jvm.hotspot.tools.jcore;
+    opens sun.jvm.hotspot.tools.soql;
+    opens sun.jvm.hotspot.asm;
+    opens sun.jvm.hotspot.asm.sparc;
+    opens sun.jvm.hotspot.compiler;
+    opens sun.jvm.hotspot.utilities;
+    opens sun.jvm.hotspot.utilities.memo;
+    opens sun.jvm.hotspot.utilities.soql;
+    opens sun.jvm.hotspot.runtime;
+    opens sun.jvm.hotspot.runtime.linux_aarch64;
+    opens sun.jvm.hotspot.runtime.solaris_amd64;
+    opens sun.jvm.hotspot.runtime.linux_sparc;
+    opens sun.jvm.hotspot.runtime.ppc64;
+    opens sun.jvm.hotspot.runtime.posix;
+    opens sun.jvm.hotspot.runtime.win32_x86;
+    opens sun.jvm.hotspot.runtime.amd64;
+    opens sun.jvm.hotspot.runtime.linux_ppc64;
+    opens sun.jvm.hotspot.runtime.x86;
+    opens sun.jvm.hotspot.runtime.solaris_sparc;
+    opens sun.jvm.hotspot.runtime.bsd;
+    opens sun.jvm.hotspot.runtime.bsd_amd64;
+    opens sun.jvm.hotspot.runtime.bsd_x86;
+    opens sun.jvm.hotspot.runtime.linux_x86;
+    opens sun.jvm.hotspot.runtime.linux_amd64;
+    opens sun.jvm.hotspot.runtime.solaris_x86;
+    opens sun.jvm.hotspot.runtime.win32_amd64;
+    opens sun.jvm.hotspot.runtime.sparc;
+    opens sun.jvm.hotspot.runtime.aarch64;
+    opens sun.jvm.hotspot.runtime.linux;
+    opens sun.jvm.hotspot.oops;
+    opens sun.jvm.hotspot.prims;
+    opens sun.jvm.hotspot.interpreter;
+    opens sun.jvm.hotspot.c1;
+    opens sun.jvm.hotspot.code;
+    opens sun.jvm.hotspot.gc.z;
+    opens sun.jvm.hotspot.gc.g1;
+    opens sun.jvm.hotspot.gc.cms;
+    opens sun.jvm.hotspot.gc.serial;
+    opens sun.jvm.hotspot.gc.parallel;
+    opens sun.jvm.hotspot.gc.epsilon;
+    opens sun.jvm.hotspot.gc.shared;
+    opens sun.jvm.hotspot.gc.shenandoah;
+    opens sun.jvm.hotspot.ui;
+    opens sun.jvm.hotspot.ui.treetable;
+    opens sun.jvm.hotspot.ui.classbrowser;
+    opens sun.jvm.hotspot.ui.table;
+    opens sun.jvm.hotspot.ui.tree;
+    opens sun.jvm.hotspot.ui.resources;
+    opens sun.jvm.hotspot.ui.action;
+    opens sun.jvm.hotspot.classfile;
+    opens sun.jvm.hotspot.ci;
+    opens sun.jvm.hotspot.opto;
 }