diff -r 5a545ce819e7 src/jdk.incubator.vector/share/classes/jdk/incubator/vector/ByteVector.java
--- a/src/jdk.incubator.vector/share/classes/jdk/incubator/vector/ByteVector.java	Wed Aug 28 12:22:15 2019 -0700
+++ b/src/jdk.incubator.vector/share/classes/jdk/incubator/vector/ByteVector.java	Fri Sep 06 19:31:28 2019 -0700
@@ -1374,6 +1374,8 @@
 
     /**
      * {@inheritDoc} <!--workaround-->
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      * @see #div(byte)
      */
     @Override
@@ -1393,10 +1395,8 @@
      *    lanewise}{@code (}{@link VectorOperators#DIV
      *    DIV}{@code , e)}.
      *
-     * <p>
-     * If the underlying scalar operator does not support
-     * division by zero, but is presented with a zero divisor,
-     * an {@code ArithmeticException} will be thrown.
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      *
      * @param e the input scalar
      * @return the result of dividing each lane of this vector by the scalar
@@ -1414,6 +1414,8 @@
 
     /**
      * {@inheritDoc} <!--workaround-->
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      * @see #div(byte,VectorMask)
      */
     @Override
@@ -1435,10 +1437,8 @@
      *    lanewise}{@code (}{@link VectorOperators#DIV
      *    DIV}{@code , s, m)}.
      *
-     * <p>
-     * If the underlying scalar operator does not support
-     * division by zero, but is presented with a zero divisor,
-     * an {@code ArithmeticException} will be thrown.
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      *
      * @param e the input scalar
      * @param m the mask controlling lane selection
diff -r 5a545ce819e7 src/jdk.incubator.vector/share/classes/jdk/incubator/vector/DoubleVector.java
--- a/src/jdk.incubator.vector/share/classes/jdk/incubator/vector/DoubleVector.java	Wed Aug 28 12:22:15 2019 -0700
+++ b/src/jdk.incubator.vector/share/classes/jdk/incubator/vector/DoubleVector.java	Fri Sep 06 19:31:28 2019 -0700
@@ -1309,7 +1309,7 @@
     /**
      * {@inheritDoc} <!--workaround-->
      * @see #div(double)
-     * <p> Because the underlying scalar operator is an IEEE
+     * @apiNote Because the underlying scalar operator is an IEEE
      * floating point number, division by zero in fact will
      * not throw an exception, but will yield a signed
      * infinity or NaN.
@@ -1331,11 +1331,7 @@
      *    lanewise}{@code (}{@link VectorOperators#DIV
      *    DIV}{@code , e)}.
      *
-     * <p>
-     * If the underlying scalar operator does not support
-     * division by zero, but is presented with a zero divisor,
-     * an {@code ArithmeticException} will be thrown.
-     * Because the underlying scalar operator is an IEEE
+     * @apiNote Because the underlying scalar operator is an IEEE
      * floating point number, division by zero in fact will
      * not throw an exception, but will yield a signed
      * infinity or NaN.
@@ -1357,7 +1353,7 @@
     /**
      * {@inheritDoc} <!--workaround-->
      * @see #div(double,VectorMask)
-     * <p> Because the underlying scalar operator is an IEEE
+     * @apiNote Because the underlying scalar operator is an IEEE
      * floating point number, division by zero in fact will
      * not throw an exception, but will yield a signed
      * infinity or NaN.
@@ -1381,11 +1377,7 @@
      *    lanewise}{@code (}{@link VectorOperators#DIV
      *    DIV}{@code , s, m)}.
      *
-     * <p>
-     * If the underlying scalar operator does not support
-     * division by zero, but is presented with a zero divisor,
-     * an {@code ArithmeticException} will be thrown.
-     * Because the underlying scalar operator is an IEEE
+     * @apiNote Because the underlying scalar operator is an IEEE
      * floating point number, division by zero in fact will
      * not throw an exception, but will yield a signed
      * infinity or NaN.
diff -r 5a545ce819e7 src/jdk.incubator.vector/share/classes/jdk/incubator/vector/FloatVector.java
--- a/src/jdk.incubator.vector/share/classes/jdk/incubator/vector/FloatVector.java	Wed Aug 28 12:22:15 2019 -0700
+++ b/src/jdk.incubator.vector/share/classes/jdk/incubator/vector/FloatVector.java	Fri Sep 06 19:31:28 2019 -0700
@@ -1309,7 +1309,7 @@
     /**
      * {@inheritDoc} <!--workaround-->
      * @see #div(float)
-     * <p> Because the underlying scalar operator is an IEEE
+     * @apiNote Because the underlying scalar operator is an IEEE
      * floating point number, division by zero in fact will
      * not throw an exception, but will yield a signed
      * infinity or NaN.
@@ -1331,11 +1331,7 @@
      *    lanewise}{@code (}{@link VectorOperators#DIV
      *    DIV}{@code , e)}.
      *
-     * <p>
-     * If the underlying scalar operator does not support
-     * division by zero, but is presented with a zero divisor,
-     * an {@code ArithmeticException} will be thrown.
-     * Because the underlying scalar operator is an IEEE
+     * @apiNote Because the underlying scalar operator is an IEEE
      * floating point number, division by zero in fact will
      * not throw an exception, but will yield a signed
      * infinity or NaN.
@@ -1357,7 +1353,7 @@
     /**
      * {@inheritDoc} <!--workaround-->
      * @see #div(float,VectorMask)
-     * <p> Because the underlying scalar operator is an IEEE
+     * @apiNote Because the underlying scalar operator is an IEEE
      * floating point number, division by zero in fact will
      * not throw an exception, but will yield a signed
      * infinity or NaN.
@@ -1381,11 +1377,7 @@
      *    lanewise}{@code (}{@link VectorOperators#DIV
      *    DIV}{@code , s, m)}.
      *
-     * <p>
-     * If the underlying scalar operator does not support
-     * division by zero, but is presented with a zero divisor,
-     * an {@code ArithmeticException} will be thrown.
-     * Because the underlying scalar operator is an IEEE
+     * @apiNote Because the underlying scalar operator is an IEEE
      * floating point number, division by zero in fact will
      * not throw an exception, but will yield a signed
      * infinity or NaN.
diff -r 5a545ce819e7 src/jdk.incubator.vector/share/classes/jdk/incubator/vector/IntVector.java
--- a/src/jdk.incubator.vector/share/classes/jdk/incubator/vector/IntVector.java	Wed Aug 28 12:22:15 2019 -0700
+++ b/src/jdk.incubator.vector/share/classes/jdk/incubator/vector/IntVector.java	Fri Sep 06 19:31:28 2019 -0700
@@ -1374,6 +1374,8 @@
 
     /**
      * {@inheritDoc} <!--workaround-->
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      * @see #div(int)
      */
     @Override
@@ -1393,10 +1395,8 @@
      *    lanewise}{@code (}{@link VectorOperators#DIV
      *    DIV}{@code , e)}.
      *
-     * <p>
-     * If the underlying scalar operator does not support
-     * division by zero, but is presented with a zero divisor,
-     * an {@code ArithmeticException} will be thrown.
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      *
      * @param e the input scalar
      * @return the result of dividing each lane of this vector by the scalar
@@ -1415,6 +1415,8 @@
     /**
      * {@inheritDoc} <!--workaround-->
      * @see #div(int,VectorMask)
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      */
     @Override
     @ForceInline
@@ -1435,10 +1437,8 @@
      *    lanewise}{@code (}{@link VectorOperators#DIV
      *    DIV}{@code , s, m)}.
      *
-     * <p>
-     * If the underlying scalar operator does not support
-     * division by zero, but is presented with a zero divisor,
-     * an {@code ArithmeticException} will be thrown.
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      *
      * @param e the input scalar
      * @param m the mask controlling lane selection
diff -r 5a545ce819e7 src/jdk.incubator.vector/share/classes/jdk/incubator/vector/LongVector.java
--- a/src/jdk.incubator.vector/share/classes/jdk/incubator/vector/LongVector.java	Wed Aug 28 12:22:15 2019 -0700
+++ b/src/jdk.incubator.vector/share/classes/jdk/incubator/vector/LongVector.java	Fri Sep 06 19:31:28 2019 -0700
@@ -1293,6 +1293,8 @@
 
     /**
      * {@inheritDoc} <!--workaround-->
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      * @see #div(long)
      */
     @Override
@@ -1312,10 +1314,8 @@
      *    lanewise}{@code (}{@link VectorOperators#DIV
      *    DIV}{@code , e)}.
      *
-     * <p>
-     * If the underlying scalar operator does not support
-     * division by zero, but is presented with a zero divisor,
-     * an {@code ArithmeticException} will be thrown.
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      *
      * @param e the input scalar
      * @return the result of dividing each lane of this vector by the scalar
@@ -1333,6 +1333,8 @@
 
     /**
      * {@inheritDoc} <!--workaround-->
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      * @see #div(long,VectorMask)
      */
     @Override
@@ -1354,10 +1356,8 @@
      *    lanewise}{@code (}{@link VectorOperators#DIV
      *    DIV}{@code , s, m)}.
      *
-     * <p>
-     * If the underlying scalar operator does not support
-     * division by zero, but is presented with a zero divisor,
-     * an {@code ArithmeticException} will be thrown.
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      *
      * @param e the input scalar
      * @param m the mask controlling lane selection
diff -r 5a545ce819e7 src/jdk.incubator.vector/share/classes/jdk/incubator/vector/ShortVector.java
--- a/src/jdk.incubator.vector/share/classes/jdk/incubator/vector/ShortVector.java	Wed Aug 28 12:22:15 2019 -0700
+++ b/src/jdk.incubator.vector/share/classes/jdk/incubator/vector/ShortVector.java	Fri Sep 06 19:31:28 2019 -0700
@@ -1375,6 +1375,8 @@
 
     /**
      * {@inheritDoc} <!--workaround-->
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      * @see #div(short)
      */
     @Override
@@ -1394,10 +1396,8 @@
      *    lanewise}{@code (}{@link VectorOperators#DIV
      *    DIV}{@code , e)}.
      *
-     * <p>
-     * If the underlying scalar operator does not support
-     * division by zero, but is presented with a zero divisor,
-     * an {@code ArithmeticException} will be thrown.
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      *
      * @param e the input scalar
      * @return the result of dividing each lane of this vector by the scalar
@@ -1415,6 +1415,8 @@
 
     /**
      * {@inheritDoc} <!--workaround-->
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      * @see #div(short,VectorMask)
      */
     @Override
@@ -1436,10 +1438,8 @@
      *    lanewise}{@code (}{@link VectorOperators#DIV
      *    DIV}{@code , s, m)}.
      *
-     * <p>
-     * If the underlying scalar operator does not support
-     * division by zero, but is presented with a zero divisor,
-     * an {@code ArithmeticException} will be thrown.
+     * @apiNote If there is a zero divisor, {@code
+     * ArithmeticException} will be thrown.
      *
      * @param e the input scalar
      * @param m the mask controlling lane selection
diff -r 5a545ce819e7 src/jdk.incubator.vector/share/classes/jdk/incubator/vector/Vector.java
--- a/src/jdk.incubator.vector/share/classes/jdk/incubator/vector/Vector.java	Wed Aug 28 12:22:15 2019 -0700
+++ b/src/jdk.incubator.vector/share/classes/jdk/incubator/vector/Vector.java	Fri Sep 06 19:31:28 2019 -0700
@@ -1635,16 +1635,15 @@
      *    DIV}{@code , v)}.
      *
      * <p>
-     * If the underlying scalar operator does not support
-     * division by zero, but is presented with a zero divisor,
-     * an {@code ArithmeticException} will be thrown.
-     *
-     * <p>
      * As a full-service named operation, this method
      * comes in masked and unmasked overloadings, and
      * (in subclasses) also comes in scalar-broadcast
      * overloadings (both masked and unmasked).
      *
+     * @apiNote If the underlying scalar operator does not support
+     * division by zero, but is presented with a zero divisor,
+     * an {@code ArithmeticException} will be thrown.
+     *
      * @param v a second input vector
      * @return the result of dividing this vector by the second input vector
      * @throws ArithmeticException if any lane
@@ -1676,16 +1675,15 @@
      *    DIV}{@code , v, m)}.
      *
      * <p>
-     * If the underlying scalar operator does not support
-     * division by zero, but is presented with a zero divisor,
-     * an {@code ArithmeticException} will be thrown.
-     *
-     * <p>
      * As a full-service named operation, this method
      * comes in masked and unmasked overloadings, and
      * (in subclasses) also comes in scalar-broadcast
      * overloadings (both masked and unmasked).
      *
+     * @apiNote If the underlying scalar operator does not support
+     * division by zero, but is presented with a zero divisor,
+     * an {@code ArithmeticException} will be thrown.
+     *
      * @param v a second input vector
      * @param m the mask controlling lane selection
      * @return the result of dividing this vector by the second input vector